(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-bootstrap-select', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-bootstrap-select'] = {}, global.ng.core));
}(this, (function (exports, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var SOptionComponent = /** @class */ (function () {
        function SOptionComponent() {
        }
        return SOptionComponent;
    }());
    SOptionComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'abs-option',
                    template: "\n\t\t<div #content>\n\t\t\t<ng-content></ng-content>\n\t\t</div>\n\t"
                },] }
    ];
    SOptionComponent.propDecorators = {
        title: [{ type: core.Input }],
        value: [{ type: core.Input }],
        selected: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        isInvalid: [{ type: core.Input }],
        content: [{ type: core.ViewChild, args: ['content',] }]
    };
    var AngularBootstrapSelectComponent = /** @class */ (function () {
        function AngularBootstrapSelectComponent() {
            var _this = this;
            this.insideClick = function () { return _this.clickInside = true; };
            this.shown = [];
            this.open = false;
            this.focusIndex = -1;
            this.clickInside = false;
        }
        AngularBootstrapSelectComponent.prototype.onKeyDown = function (evt) {
            switch (evt.key) {
                case "Enter":
                    {
                        if (this.focusIndex >= 0 && !this.shown[this.focusIndex].disabled)
                            this.optionSelect(this.shown[this.focusIndex]);
                        break;
                    }
                case 'ArrowDown':
                    {
                        if (this.focusIndex == this.shown.length - 1)
                            this.focusIndex = 0;
                        else
                            this.focusIndex += 1;
                        break;
                    }
                case 'ArrowUp':
                    {
                        if (this.focusIndex == 0)
                            this.focusIndex = this.shown.length - 1;
                        else
                            this.focusIndex -= 1;
                        break;
                    }
            }
        };
        AngularBootstrapSelectComponent.prototype.outsideClick = function () {
            if (!this.clickInside)
                this.open = false;
            this.clickInside = false;
        };
        // riconosce se c'è un'opzione che ha per TITOLO ESATTO ciò che viene scritto nella input
        // il titolo viene comparato senza spazi iniziali/finali (trim) e in minuscolo (toLowerCase)
        AngularBootstrapSelectComponent.prototype.recognizeInput = function (e) {
            var corrOption, input, value;
            input = e.target;
            value = input.value.toLowerCase().trim();
            corrOption = this.children.find(function (e) { return e.title.toLowerCase().trim() === value; });
            if (!corrOption || corrOption.disabled) {
                var selected = this.children.filter(function (op) { return !!op.selected; })[0];
                input.value = selected ? selected.title : '';
            }
            else {
                this.optionSelect(corrOption);
                input.value = corrOption.title;
            }
        };
        AngularBootstrapSelectComponent.prototype.getSelected = function () {
            return this.children.filter(function (op) { return !!op.selected; });
        };
        AngularBootstrapSelectComponent.prototype.onControlClick = function () {
            if (!this.open)
                this.open = true;
            if (this.multiple)
                this.input.nativeElement.focus();
        };
        AngularBootstrapSelectComponent.prototype.search = function (evt) {
            this.focusIndex = -1;
            var key = evt.target.value.trim().toLowerCase();
            this.shown = this.children.filter(function (op) { return op.title.toLowerCase().includes(key) ||
                op.value.toLowerCase().includes(key); });
        };
        AngularBootstrapSelectComponent.prototype.adjustPosition = function () {
            //console.log( this.list.nativeElement.offsetTop, this.list.nativeElement.offsetHeight );
            this.list.nativeElement.style.top = this.control.nativeElement.offsetHeight + "px";
        };
        AngularBootstrapSelectComponent.prototype.setupOptions = function () {
            this.shown = __spread(this.children.toArray());
        };
        AngularBootstrapSelectComponent.prototype.getControlText = function () {
            if (!this.children)
                return '';
            var selected = this.children.filter(function (op) { return !!op.selected; });
            if (selected.length > 0)
                return selected[0].title;
            else
                return '';
        };
        AngularBootstrapSelectComponent.prototype.optionSelect = function (option) {
            if (!this.multiple)
                this.children.forEach(function (op) { return op.selected = false; });
            this.children.find(function (el) { return el.value == option.value; }).selected = true;
            if (this.multiple) {
                this.input.nativeElement.value = '';
            }
            if (!this.multiple)
                this.open = false;
            if (!!this.onChange)
                this.onChange(this.children.map(function (el) { return el.value; }));
        };
        AngularBootstrapSelectComponent.prototype.deselect = function (op) {
            this.children.find(function (el) { return el.value == op.value; }).selected = false;
            if (!!this.onChange)
                this.onChange(this.children.map(function (el) { return el.value; }));
        };
        AngularBootstrapSelectComponent.prototype.hasFocus = function (op) {
            if (!this.shown.find(function (el) { return el.value == op.value; }))
                return false;
            return this.children.toArray().indexOf(op) == this.focusIndex % this.shown.length;
        };
        AngularBootstrapSelectComponent.prototype.hoverOption = function (op) {
            this.input.nativeElement.focus();
            this.focusIndex = this.shown.indexOf(op);
        };
        AngularBootstrapSelectComponent.prototype.ngOnChanges = function (changes) {
            console.log(changes);
        };
        AngularBootstrapSelectComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.setupOptions();
            this.children.changes.subscribe(function () { return _this.setupOptions(); });
        };
        AngularBootstrapSelectComponent.prototype.ngOnInit = function () { };
        return AngularBootstrapSelectComponent;
    }());
    AngularBootstrapSelectComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'abs-select',
                    template: "<div \n\tclass=\"abs-select\"\n\t[attr.multiple]=\"multiple\"\n\t[attr.active]=\"open\" \n\t[attr.invalid]=\"invalid\"\n>\n\t<input \n\t\t#input \n\t\t*ngIf=\"!multiple\" \n\t\tclass=\"abs-control form-control\" \n\t\t[readOnly]=\"!open\"\n\t\t[value]=\"getControlText()\"\n\t\t(input)=\"search( $event )\"\n\t\t(click)=\"onControlClick()\"\n\t\t(change)=\"recognizeInput( $event )\"\n\t/>\n\n\t<div \n\t\t#control\n\t\t*ngIf=\"multiple\"\n\t\tclass=\"abs-control form-control\"\n\t\t(click)=\"onControlClick()\"\n\t>\n\t\t<span \n\t\t\tclass=\"abs-pill\"\n\t\t\t*ngFor=\"let p of getSelected()\"\n\t\t>\n\t\t\t{{p.title}}\n\t\t\t<i (click)=\"deselect( p )\">&times;</i>\n\t\t</span>\n\n\t\t<div class=\"clearfix\"></div>\n\t\t\n\t\t<input \n\t\t\t#input\n\t\t\t[readOnly]=\"!open\"\n\t\t\t(input)=\"search( $event )\"\n\t\t\t(change)=\"recognizeInput( $event )\"\n\t\t/>\n\t</div>\n\n\t<ul #list\n\t\tclass=\"list-group abs-list mt-2\">\n\t\t<li \n\t\t\t*ngFor=\"let el of shown\"\n\t\t\tclass=\"list-group-item\"\n\t\t\t[attr.active]=\"!!el.selected\"\n\t\t\t[attr.disabled]=\"!!el.disabled\"\n\t\t\t[attr.value]=\"el.value\"\n\t\t\t[attr.focus]=\"this.hasFocus( el )\"\n\t\t\t(click)=\"optionSelect(el)\"\n\t\t\t(mouseover)=\"hoverOption(el)\"\n\t\t>\n\t\t\t{{el.title}}\n\t\t\t<div \n\t\t\t\tclass=\"mt-3\"\n\t\t\t\t*ngIf=\"el.content.nativeElement.innerText.length > 0\" \n\t\t\t\t[innerHTML]=\"el.content.nativeElement.innerHTML\"\n\t\t\t>\n\t\t\t</div>\n\t\t</li>\n\t</ul>\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".clearfix{clear:both}.abs-select input:not(.form-control){-moz-appearance:none;-webkit-appearance:none;appearance:none;border:none}.abs-select input:not(.form-control):focus{outline:none}.abs-select .form-control:focus{border-color:#ced4da;box-shadow:none}.abs-select .form-control[readonly]{background-color:#fff;color:#495057}.abs-select[invalid=true] .abs-control{border-color:#dc3545}.abs-select[invalid=true][active=true] .abs-control{background-color:#fff;border-color:#efa2a9!important;box-shadow:0 0 0 0 0 0 .2rem rgba(220,53,69,.25);color:#495057;outline:0}.abs-select[active=true] .abs-control{background-color:#fff;border-color:#80bdff!important;box-shadow:0 0 0 .2rem rgba(0,123,255,.25);color:#495057;outline:0}.abs-select[active=true] .abs-list{display:flex}.abs-select[multiple=true] .abs-control{border:1px solid #ced4da;border-radius:.25rem;height:unset;max-height:unset;min-height:calc(1.5em + .75rem + 2px)}.abs-select[multiple=true] .abs-control>input{display:block;height:calc(1.5em + 2px);width:100%}.abs-select[multiple=true] .abs-control>.abs-pill{align-items:center;background-color:#f3f4f5;border:1px solid #dee2e6;border-radius:.25rem;display:flex;float:left;font-size:small;font-weight:400;margin:0 .25rem .375rem 0;padding:.25rem 1rem;width:auto}.abs-select[multiple=true] .abs-control>.abs-pill>i{cursor:pointer;height:100%;padding-left:.5rem}.abs-select .abs-list{display:none;width:100%}.abs-select .abs-list>li{cursor:pointer;position:static}.abs-select .abs-list>li[focus=true]{background-color:#f4f5f7}.abs-select .abs-list>li[active=true]{background-color:#007bff;border-color:#007bff;color:#fff}.abs-select .abs-list>li[disabled=false][active=true]:hover,.abs-select .abs-list>li[disabled=false][active=true][focus=true]{background-color:#0069d9;border-color:#007bff;color:#fff}.abs-select .abs-list>li[disabled=true]{background-color:#fff;color:#6c757d;cursor:not-allowed!important;pointer-events:none}"]
                },] }
    ];
    AngularBootstrapSelectComponent.ctorParameters = function () { return []; };
    AngularBootstrapSelectComponent.propDecorators = {
        invalid: [{ type: core.Input }],
        multiple: [{ type: core.Input }],
        required: [{ type: core.Input }],
        onChange: [{ type: core.Input }],
        input: [{ type: core.ViewChild, args: ['input',] }],
        control: [{ type: core.ViewChild, args: ['control',] }],
        list: [{ type: core.ViewChild, args: ['list',] }],
        children: [{ type: core.ContentChildren, args: [SOptionComponent,] }],
        insideClick: [{ type: core.HostListener, args: ['click',] }],
        onKeyDown: [{ type: core.HostListener, args: ['keydown', ['$event'],] }],
        outsideClick: [{ type: core.HostListener, args: ['document:click',] }]
    };

    var AngularBootstrapSelectModule = /** @class */ (function () {
        function AngularBootstrapSelectModule() {
        }
        return AngularBootstrapSelectModule;
    }());
    AngularBootstrapSelectModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [AngularBootstrapSelectComponent],
                    imports: [],
                    exports: [AngularBootstrapSelectComponent]
                },] }
    ];

    /*
     * Public API Surface of angular-bootstrap-select
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularBootstrapSelectComponent = AngularBootstrapSelectComponent;
    exports.AngularBootstrapSelectModule = AngularBootstrapSelectModule;
    exports.SOptionComponent = SOptionComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-bootstrap-select.umd.js.map
