import { ElementRef, OnChanges, OnInit, QueryList, SimpleChanges } from '@angular/core';
export declare class SOptionComponent {
    title: string;
    value: string;
    selected?: boolean;
    disabled?: boolean;
    isInvalid?: boolean;
    content: any;
}
export declare class AngularBootstrapSelectComponent implements OnInit, OnChanges {
    invalid?: boolean;
    multiple?: boolean;
    required?: boolean;
    onChange?: (values: string[]) => any;
    input: ElementRef<HTMLInputElement>;
    control: ElementRef<HTMLDivElement>;
    list: ElementRef<HTMLUListElement>;
    children: QueryList<SOptionComponent>;
    open: boolean;
    focus: boolean;
    className: string;
    clickInside: boolean;
    focusIndex: number;
    shown: SOptionComponent[];
    insideClick: () => boolean;
    onKeyDown(evt: KeyboardEvent): void;
    outsideClick(): void;
    recognizeInput(e: Event): void;
    getSelected(): SOptionComponent[];
    onControlClick(): void;
    search(evt: Event): void;
    adjustPosition(): void;
    setupOptions(): void;
    getControlText(): string;
    optionSelect(option: any): void;
    deselect(op: SOptionComponent): void;
    hasFocus(op: SOptionComponent): boolean;
    hoverOption(op: SOptionComponent): void;
    constructor();
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
}
